#pragma once

#include <Arduino.h>


struct PixelMessage
{
public:
	PixelMessage();
	PixelMessage(byte* rawMessage);
	~PixelMessage();

	/// <summary>
	/// The length of the message header, in bytes.
	/// The message header contains things like the protocol version, the payload length, and the message type.
	/// </summary>
	static const unsigned int MESSAGE_HEADER_LENGTH = 12;
	
	static const unsigned int TYPE_RESET = 0;
	static const unsigned int TYPE_ERROR = 1;
	static const unsigned int TYPE_HANDSHAKEREQUEST = 5;
	static const unsigned int TYPE_HANDSHAKERESPONSE = 6;
	static const unsigned int TYPE_MOVE = 11;
	static const unsigned int TYPE_COMMANDOK = 12;
	static const unsigned int TYPE_COMMANDCOMPLETE = 13;
	static const unsigned int TYPE_COMMANDFAILED = 14;
	static const unsigned int TYPE_INFOREQUEST = 20;
	static const unsigned int TYPE_INFORESPONSE = 21;

	// The protocol version associated with this message.
	unsigned short ProtocolVersion = 1;
	unsigned short MessageType = 1;
	unsigned int MessageId = 0;
	unsigned int MessageLength = 0;

	//const byte* Payload;
	
private:
	
};
