﻿using System;

namespace PixelHub.Server.PixelMessages
{
	/// <summary>
	/// Hard-resets the PixelBot. Useful if something has gone wrong, or to reset it's internal state.
	/// Note that this will cause the PixelBot to drop it's connection!
	/// </summary>
	public class ResetMessage : PixelMessage
	{
		public override byte[] Payload {
			get {
				return new byte[0];
			}
			protected set {
				// There's nothing here!
			}
		}

		public new MessageTypes MessageType { get; private set; } = MessageTypes.Reset;

		public ResetMessage()
		{
			
		}
	}
}

