# PixelHub

A combination of a C# server and an arduino program that allows the control of a Hull Pixelbot.

## PixelHub Cilent protocol
The PixelHub client protocol is a (mostly) binary-based protocol that the server uses to talk to the PixelBot and give it instructions. It is documented in the [PixelHub Protocol](https://git.starbeamrainbowlabs.com/sbrl/PixelHub/src/master/PixelHub%20Protocol.md) file.


## Split-brain robots
If you have a split brain robot, the PixelHub client, while it doesn't support it yet, _can_ be adjusted to add support. Currently, all you need to do is swap out the `PixelHubController` .cpp file with one that can talk to your other microcontroller that actually controls the wheels.

## Credits
 - Debugging:
 	- Andrew C, Karen van Eck, Mike C
 - Soldering:
 	- Brian N

## Useful Links
 - [Rob's Advanced Motor Controller](https://github.com/HullPixelbot/RobotSensorsAndMotors/blob/master/MotorControl.h)

### Tcp Client
 - [ESP8266 examples](https://github.com/esp8266/Arduino/tree/master/libraries/ESP8266WiFi/examples)
 - [WiFiClient header file](https://github.com/esp8266/Arduino/blob/master/libraries/ESP8266WiFi/src/WiFiClient.h)

### For Multicast networkinterface blog post
 - [NetworkInterface class](https://msdn.microsoft.com/en-us/library/system.net.networkinformation.networkinterface(v=vs.110).aspx)
 - [Stackoverflow answer](http://stackoverflow.com/questions/2192548/specifying-what-network-interface-an-udp-multicast-should-go-to-in-net)
 - [IPv4InterfaceProperties](https://msdn.microsoft.com/en-us/library/system.net.networkinformation.ipv4interfaceproperties(v=vs.110).aspx)

### Bits and Bobs
 - [NeoPixel](https://www.aliexpress.com/item/12-Bits-12-X-WS2812-5050-RGB-LED-Ring-Lamp-Light-with-Integrated-Drivers/32674296246.html?ws_ab_test=searchweb0_0,searchweb201602_2_10065_10068_10000009_10000032_10084_10000025_10083_10000029_10080_10082_10081_10000028_10110_10111_10060_10112_10113_10062_10114_10115_10056_503_10055_10054_10059_10000044_10099_501_10078_10079_10000022_10000012_10103_429_10073_10102_10000015_10000035_10096_10000018_10000019_10052_10053_10107_10050_10106_10051-10050,searchweb201603_3,afswitch_1,single_sort_3_default&btsid=d363368f-3ac5-4403-8a5a-6457cb863a7b)
 
